/*********************************************************************
 *	PIC18 Flashǂ݁E.
 *********************************************************************

ڑ:

 AVRpISP 6PIN                  PIC18F2550/14K50

	1 MISO    ------------------   PGD
	2 Vcc     ------------------   Vcc
	3 SCK     ------------------   PGC
	4 MOSI    ------------------   PGM
	5 RESET   ------------------   MCLR
	6 GND     ------------------   GND

 *********************************************************************
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "monit.h"
#include "util.h"
#include "hidasp.h"
#include "picdevice.h"

#define	DEBUG_CMD	0
#define	PIC18F14K50	1

int	portAddress(char *s);

#if	HIDMON88
enum {
	SCK =5,
	MISO=4,
	MOSI=3,
	SS  =2,
};
#else
// tiny2313
enum {
	SCK =7,
	MISO=5,
	MOSI=6,
	SS  =4,
};
#endif

enum {
	b_0000 = 0x00,
	b_1000 = 0x08,
	b_1001 = 0x09,
	b_1100 = 0x0c,	//
	b_1101 = 0x0d,	// TBLPTR+=2
	b_1111 = 0x0f,	// Write!
};

#define	PGM	 MOSI
#define	PGC	 SCK
#define	PGD	 MISO
#define	MCLR SS

#define	if_D	if(DEBUG_CMD)


/*********************************************************************
 *	P~bPʂ̎ԑ҂. Windows Sleep()֐Ăяo.
 *   ۂ̊֐́Ahidasp.c ɂB
 *********************************************************************
 */

extern void wait_ms(int ms);

/*********************************************************************
 *	PʕbPʂ̎ԑ҂.
 *********************************************************************
 *	WindowsłUSBt[Ԃ̏̂ŁAۂɂ͕sv.
 *	}CRt@[ɈڐAƂ̓}CRłꂼ̕Kv.
 */
void wait_us(int us)
{
	int ms = us / 1000;

	if(ms) wait_ms(ms);
}

/*********************************************************************
 *
 *********************************************************************
 */
static  int datab=0;	// PortB ɍŌɏ񂾒loĂ.

//	e|[g̎AhXێ.
static	int	Portb;
static	int Pinb ;
static	int Ddrb ;		// 1=out 0=in

/*********************************************************************
 *	USBoRă|[gւ݂̏s.
 *********************************************************************
 */
static void set_port(int adr,int data)
{
	UsbPoke(adr,0,data,0);
}

/*********************************************************************
 *	USBoRă|[g̓ǂݏos.
 *********************************************************************
 */
static int  get_port(int adr)
{
	return UsbPeek(adr,0);
}
/*********************************************************************
 *	|[gȁݐp.Ōɏ񂾒loĂ.
 *********************************************************************
 */
static void set_portb(int data)
{
	set_port(Portb,data);
	datab = data;
}

/*********************************************************************
 *	|[gȁ݃f[^ɑ΂ĔCӃrbgOn/Off (ۂ݂͍̏sȂ)
 *********************************************************************
 */
static void set_bitf(int bit,int f)
{
	if(f) {
		datab |=  (1<<bit);
	}else{
		datab &= ~(1<<bit);
	}
}

/*********************************************************************
 *	|[gȁ݃f[^ɑ΂ĔCӃrbgOn/OffsA݂s.
 *********************************************************************
 */
static void set_bit(int bit,int f)
{
	set_bitf(bit,f);
	set_portb(datab);
}


/*********************************************************************
 *	PGDrbg̓o͕؂ւ.(0=)
 *********************************************************************
 *	f=0 ... PGD=in
 *	f=1 ... PGD=out
 */

void SetPGDDir(int f)
{
	int dirb = (1<<PGC) | (1<<PGM) | (1<<MCLR);

	if(f) dirb |= (1<<PGD);

	set_port(Ddrb ,dirb);
}

/*********************************************************************
 *	
 *********************************************************************
 */
void PicInit(void)
{
	Portb = portAddress("portb");
	Pinb  = portAddress("pinb");
	Ddrb  = portAddress("ddrb");

	set_portb(0);
	SetPGDDir(1);		// PGD=out
}

/*********************************************************************
 *	PIC^[Qbgւ̃ANZXJn (f=1) / I(f=0)
 *********************************************************************
 */
void PicPgm(int f)
{
	if(f) {
		set_portb(0);	//SĂ̐MLɂ.
		wait_ms(1);
		set_bit(PGM,1);	// PGM=H
		wait_ms(1);
		set_bit(MCLR,1);// MCLR=H
	}else{
		set_bit(PGD,0);// MCLR=L
		set_bit(PGC,0);// MCLR=L
		wait_ms(1);
		set_bit(MCLR,0);// MCLR=L
		wait_ms(1);
		set_bit(PGM,0);	// PGM=L
		wait_ms(1);
		set_portb(0);	//SĂ̐MLɂ.
	}
}

/*********************************************************************
 *	1bitM.
 *********************************************************************

        +---+
  PGC --+   +---

  PGD [ b=0ȂL ]
        b=1ȂH
 */
void SetCmdb1(int b)
{
	set_bitf(PGD,b);
	set_bit(PGC,1);wait_us(1);
	set_bit(PGC,0);wait_us(1);
if_D	printf("%d",b);
}

void SetCmdb1Long(int b,int ms)
{
	set_bitf(PGD,b);
	set_bit(PGC,1);wait_ms(ms);
	set_bit(PGC,0);wait_us(1);
if_D	printf("%d",b);
}

/*********************************************************************
 *	1bitM.
 *********************************************************************
        +---+
  PGC --+   +---

            œǂ.

  PGD [     ]
 */
int GetCmdb1(void)
{
	int b;

	set_bit(PGC,1);wait_us(1);

	b = get_port(Pinb) & (1<<PGD);

	set_bit(PGC,0);wait_us(1);

	return b;
}
/*********************************************************************
 *	n bit M.
 *********************************************************************
 */
void SetCmdN(int cmdn,int len)
{
	int i,b;
if_D	printf("[");

	for(i=0;i<len;i++) {
		b = cmdn & 1;
		SetCmdb1(b);
		cmdn >>=1;
	}
if_D	printf("]");

	if(len>=16) {
if_D	printf("\n");
	}
}

/*********************************************************************
 *	4 bit M , Ō PGC_HԂw.
 *********************************************************************
 */
void SetCmd4Long(int cmdn,int ms)
{
	int i,b;
if_D	printf("[");

	for(i=0;i<3;i++) {
		b = cmdn & 1;
		SetCmdb1(b);
		cmdn >>=1;
	}
	{
		b = cmdn & 1;
		SetCmdb1Long(b,ms);
	}
if_D	printf(" } ");
}

/*********************************************************************
 *	8 bit M.
 *********************************************************************
 */
int GetData8b(void)
{
	int i,data8=0,mask=1;
	SetPGDDir(0);		// PGD=in

	for(i=0;i<8;i++,mask<<=1) {
		if( GetCmdb1() ) {
			data8 |= mask;
		}
	}
	SetPGDDir(1);		// PGD=out
	return data8;
}

/*********************************************************************
 *	4bit̃R}h  16bit̃f[^𑗐M.
 *********************************************************************
 */
void SetCmd16(int cmd4,int data16)
{
	SetCmdN(cmd4,4);
	SetCmdN(data16,16);
}

/*********************************************************************
 *	4bit̃R}h  16bit̃f[^𑗐M.
 *********************************************************************
 */
void SetCmd16Long(int cmd4,int data16,int ms)
{
	SetCmd4Long(cmd4,ms);
	SetCmdN(data16,16);
}

/*********************************************************************
 *	TBLPTR PoCgǂݏo. TBLPTR̓|XgECNg.
 *********************************************************************
 */
int GetData8(void)
{
	SetCmdN(b_1001,4);
	SetCmdN(0 , 8);
	return GetData8b();
}

/*********************************************************************
 *	TBLPTR[U,H,L] ̂ǂꂩ8bitlZbg.
 *********************************************************************
 */
void SetAddress8x(int adr,int inst)
{
	adr &= 0x00ff;
	adr |= 0x0e00;

	SetCmd16(b_0000,adr);		// 0E xx  : MOVLW xx
	SetCmd16(b_0000,inst);		// 6E Fx  : MOVWF TBLPTR[U,H,L]
}
/*********************************************************************
 *	TBLPTR 24bitAhXZbg.
 *********************************************************************
 */
void SetAddress24(int adr)
{
	SetAddress8x(adr>>16,0x6ef8);	// TBLPTRU
	SetAddress8x(adr>>8 ,0x6ef7);	// TBLPTRH
	SetAddress8x(adr    ,0x6ef6);	// TBLPTRL
}

/*********************************************************************
 *	`bvR}h̔s.
 *********************************************************************
 */
void EraseCmd(int cmd05,int cmd04)
{
	SetAddress24(0x3c0005);
	SetCmd16(b_1100,cmd05);

	SetAddress24(0x3c0004);
	SetCmd16(b_1100,cmd04);

	SetCmd16(b_0000,0x0000);	// NOP
	SetCmd16(b_0000,0x0000);	// NOP
	wait_ms(300);
}
/*********************************************************************
 *	oNEC[X.
 *********************************************************************
 */
void BulkErase(int cmd80)
{
	switch(cmd80) {
	 default:
	 case Command80  :
		EraseCmd(0x0000,0x8080);break;

	 case Command81  :
		EraseCmd(0x0f0f,0x8f8f);break;	// mod by senshu

	 case Command3F8F:
		EraseCmd(0x3f3f,0x8f8f);break;

	}
}
/*********************************************************************
 *	݃eXg.
 *********************************************************************
 */
#define Flash_Wait	(2)		/* Ŝ */
void WriteFlash(int adr,uchar *buf,int wlen)
{
	int data;
	int i;

	SetCmd16(b_0000,0x8EA6);	//BSF   EECON1, EEPGD
	SetCmd16(b_0000,0x9CA6);    //BCF   EECON1, CFGS
	SetCmd16(b_0000,0x84A6);    //BSF   EECON1, WREN
	SetAddress24(adr);
	for(i=0;i<wlen-1;i++) {
		data = buf[0]|(buf[1]<<8);buf+=2;
		SetCmd16(b_1101,data);
	}
	{	//Ō̂P[h.
		data = buf[0]|(buf[1]<<8);
		SetCmd16(b_1111,data);
		SetCmd16Long(b_0000,0x0000,Flash_Wait);	// NOP 1mS̑҂m
	}
}

#define	FW	7	// 5mSŏ\ASׁ̈A7mSɂ(by senshu)
/*********************************************************************
 *	݃eXg.
 *********************************************************************
 */
void WriteFuse(uchar *buf)
{
	int adr = 0x300000;
	int i,data;
	SetCmd16(b_0000,0x8EA6);	//BSF   EECON1, EEPGD
	SetCmd16(b_0000,0x8CA6);    //BSF   EECON1, CFGS
	SetCmd16(b_0000,0x84A6);    //BSF   EECON1, WREN
#if	1
	//svc.Ɖ񏑂Ă [Ȃ.
	SetCmd16(b_0000,0xef00);	// GOTO 10000H ???
	SetCmd16(b_0000,0xf800);
	// PIC18Test.exe RsyĂ܂.
#endif
	SetAddress24(adr);
	for(i=0;i<7;i++) {
		data = buf[0]|(buf[1]<<8);buf+=2;//fusedata[i];

//		printf("%04x\n",data);			// for DEBUG

		SetCmd16(b_1111,data);			// set DATA
		SetCmd16Long(b_0000,0x0000,FW);	// NOP(Write)
		SetCmd16(b_0000,0x2af6);		// INCF TBLPTRL

		SetCmd16(b_1111,data);			// set DATA
		SetCmd16Long(b_0000,0x0000,FW);	// NOP(Write)
		SetCmd16(b_0000,0x2af6);		// INCF TBLPTRL
	}
#if	0
	//͕sv.
	SetCmd16(b_0000,0x94A6);    //BCF   EECON1, WREN
	SetCmd16(b_0000,0x9CA6);    //BCF   EECON1, CFGS
#endif
	wait_ms(100);
}
/*********************************************************************
 *	ǂݏoeXg[`EC.
 *********************************************************************
 */
void ReadFlash(int adr,uchar *buf,int len,int dumpf)
{
	int i,c;

	if(dumpf)printf("%06x :",adr);

	SetAddress24(adr);
	for(i=0;i<len;i++) {
		c = GetData8();
		*buf++ = c;
		if(dumpf)printf(" %02x",c);
	}

	if(dumpf)printf("\n");


#if	0
	for(i=0;i<len;i++) {
		printf(" %02x",GetData8());
	}
	printf("\n");
#endif
}
/*********************************************************************
 *
 *********************************************************************
 */
#if	0
void PicRead(char *buf,int cnt)
{
	int adr=0;
	uchar rbuf[256];
	if( strcmp(buf,"on")==0 ) {
		printf("PGM ON\n");
		PicPgm(1);return;
	}
	if( strcmp(buf,"off")==0 ) {
		printf("PGM OFF\n");
		PicPgm(0);return;
	}
	if( strcmp(buf,"erase")==0 ) {
		printf("ERASE\n");
		BulkErase();return;
	}
	if( strcmp(buf,"write")==0 ) {
		printf("WRITE\n");
//		WriteFlash();
		return;
	}
	if( strcmp(buf,"wfuse")==0 ) {
		printf("WRITE FUSE\n");
		WriteFuse();return;
	}

	if( sscanf(buf,"%x",&adr) ) {
		ReadFlash(adr,rbuf,cnt);
	}
}
#endif
/*********************************************************************
 *
 *********************************************************************
 */
